'  Plasmagenerator voor QBasic December 1994
'  Werkt op alle machine's maar wel graag met kleurenmonitor.
'  Functioneert in QBasic 5, 6 en 6.20 van MS-DOS niet in PowerBasic!

DECLARE SUB SetPal (j%)
DECLARE SUB Schermvuller (x1%, y1%, x2%, y2%)
DECLARE SUB NewCol (xa%, ya%, x%, y%, xb%, yb%)
DECLARE SUB SetRGB (Nr%, r%, g%, b%)

DEFINT A-Z
CONST PlasmaDichtheid! = 2:   ' Pas de PlasmaDichtheid! aan naar uw wensen:
                              ' 0.1 tot 1.0 (Sierpinski driehoek)
                              ' 2.0 tot 2.5 (Ideale Plasma zoals in spellen)
                              ' 2.8 tot 5.0 (Grotere grofheid)
                              ' 20 en hoger alln punten!
RANDOMIZE -TIMER
SCREEN 13
SetPal 0
CALL Schermvuller(0, 0, 320, 199)

SnelHeid = 5000: ' Pas dit aan aan uw processorsnelheid
                 ' Het heeft gn invloed op de beeldopbouw-snelheid!
                 ' Voor QBASIC bv.: 1000 en voor QB45 bv.: 5000

WHILE INKEY$ <> CHR$(27)
   SetPal (j%)
   j% = j% + 1
   FOR tmp = 1 TO SnelHeid: NEXT: 'Wachtloop wisseling der kleuren
WEND
SCREEN 0: END

SUB NewCol (xa%, ya%, x%, y%, xb%, yb%)

   '  Maakt nieuwe kleur uit een gemiddelde waarde van de voorge-
   '  plaatste pixels en voegt er een toevalswaarde aan toe.
  
   col = ABS(xa% - xb%) + ABS(ya% - yb%)
opnieuw:
   tmp = RND
   IF tmp < .5 GOTO opnieuw
   col = RND * PlasmaDichtheid! * col - col
   col = (col + POINT(xa%, ya%) + POINT(xb%, yb%)) \ 2

   '  Hier worden maxi- en mini- male waarden gecontroleerd op overloop.
  
   IF col < 1 THEN col = 1
   IF col > 180 THEN col = 1
   IF POINT(x%, y%) = 0 THEN PSET (x%, y%), col
END SUB

SUB Schermvuller (x1%, y1%, x2%, y2%)

   '  Rekursive methode om het scherm te vullen; jammer erg langzaam!
   IF NOT (x2% - x1% < 2 AND y2% - y1% < 2) THEN
      x = (x1% + x2%) \ 2
      y = (y1% + y2%) \ 2

   '  Stelt vier hoekpunten in.
      NewCol x1%, y1%, x, y1%, x2%, y1%
      NewCol x2%, y1%, x2%, y, x2%, y2%
      NewCol x1%, y2%, x, y2%, x2%, y2%
      NewCol x1%, y1%, x1%, y, x1%, y2%

   '  Gemiddlde van de vier hoekpunten.
      col = POINT(x1%, y1%) + POINT(x2%, y1%) + POINT(x2%, y2%) + POINT(x1%, y2%)
      col = col \ 4
      PSET (x, y), col

   '  Bestaande beeldscherm uitsnede.
      Schermvuller x1%, y1%, x, y
      Schermvuller x, y1%, x2%, y
      Schermvuller x, y, x2%, y2%
      Schermvuller x1%, y, x, y2%
   END IF
END SUB

SUB SetPal (j%)

Maxa = 63: ' probeer ook bijvoorbeeld 43 / PAS OP!! 63 IS MAXIMUM!
Maxb = 63: ' probeer ook hier 43 / PAS OP!! 63 IS MAXIMUM!
           ' 
   '  Plasmapalette uitrekenen en instellen.
   FOR i = 1 TO Maxa
      CALL SetRGB(i + j%, 0, Maxb - 1, i)
      CALL SetRGB(i + Maxb + j%, i, 0, Maxb - i)
      CALL SetRGB(i + 126 + j%, Maxb - i, i, 0)
   NEXT
END SUB

SUB SetRGB (Nr%, r%, g%, b%)
   '  Stelt de waarde in der kleuren met de instructie: (OUTports).
   OUT &H3C8, Nr%
   OUT &H3C9, r%
   OUT &H3C9, g%
   OUT &H3C9, b%
END SUB

