@echo off
ARJ %1 %2 %3 >nul:
if errorlevel 9 goto not_arj
if errorlevel 8 goto no_memory
if errorlevel 7 goto bad_par
if errorlevel 6 goto cant_open
if errorlevel 5 goto disk_full
if errorlevel 4 goto sec_err
if errorlevel 3 goto crc_err
if errorlevel 2 goto fat_err
if errorlevel 1 goto minor_error
if errorlevel 0 goto arj_oke

:arj_oke
echo Het archive is aangemaakt.
dir *.arj /w
echo ----------------------------------------------------------------------
goto exit

:no_memory
echo Er is niet voldoende geheugen beschikbaar om de ARJ aan te maken.
echo Verwijder eerst enkele TSR's tot u genoeg geheugenruimte hebt.
goto exit

:bad_par
echo U heeft een fout gemaakt in de parameters.
echo.
echo Meest gebruikte is de volgende:
echo.
echo     ARJ A %2 %3
echo.
echo     ARJ A -R %2 %3
echo.
echo U heeft hetvolgende ingetikt: ARJ %1 %2 %3
echo.
goto exit

:cant_open
echo Ik kan het archive of de file niet vinden welke u bedoelt.
dir *.arj /w
echo ----------------------------------------------------------------------
echo.
goto exit

:disk_full
echo Diskette of harddisk is vol. Maak ruimte of ga op een andere
echo drive opnieuw beginnen met inpakken.
goto exit
:sec_err
echo U heeft geprobeerd een ARJ file met securitylevel aan te passen.
echo Hiermee zou het zegel verbroken worden.
echo.
goto exit

:crc_err
echo ATTENTIE !!!
echo Er is een CRC error geconstateerd. Een of meer bestanden zijn
echo al dan niet onherstelbaar beschadigd geraakt.
echo.
goto exit

:fat_err
echo Er is een fatale fout opgetreden. Neem kontakt op met de auteur
echo van de ARJ archiver.
echo.
goto exit

:minor_error
echo Ik kan de files '%3' niet vinden.
echo Het archive '%2' is niet aangemaakt/updated.
echo.
goto exit

:exit
